import java.util.*;
/**
 * Klasse um Die Qualitaetskontrolle von Produkten zu  modelieren.
 */
public class Qualitaetskontrolle {
	/**
	 * liefert das Subset alle heilen Produkte zur&uuml;
	 * @param produkte Liste aller zu pr&uuml;fenden Produkte
	 * @return LinkedList alle heilen Produkte in produkte
	 */
	public static LinkedList pruefe(LinkedList produkte) {
		LinkedList out = new LinkedList();
		ListIterator li = produkte.listIterator(0);
		while(li.hasNext()) {
			Produkt next = (Produkt)li.next();
			if (next.isWorking() == true) {
				out.add(next);
			}
		}
		return(out);
	}
	/**
	 * liefert das Subset alle ausreichend billigen Produkte zur&uuml;ck
	 * @param produkte Liste aller zu pr&uuml;fenden Produkte
	 * @param preisgrenze H&ouml;chstpreis
	 * @return  LinkedList alle Produkte billiger als preisgrenze
	 */
	public static LinkedList billiger(LinkedList produkte, double preisgrenze) {
		LinkedList out = new LinkedList();
		ListIterator li = produkte.listIterator(0);
		while(li.hasNext()) {
			Produkt next = (Produkt)li.next();
			if (next.getPrice() < preisgrenze) {
				out.add(next);
			}
		}
		return(out);
	}	
}
